﻿/* Ejercicios de Deducción Natural en Lógica de Primer Orden
    para el curso de "Lógica informática (2006-07)" 

    José A. Alonso (jalonso@us.es) 
    Sevilla, 12 de Abril de 2004 (versión de 2 de Mayo de 2007)
    ===========================================================================
  */

TACTIC TheoremForward (thm) IS CUTIN (ALT thm (RESOLVE thm))

TACTIC TheoremForwardOrBackward(thm) IS
    WHEN    
        (LETHYP _A 
            (ALT    (TheoremForward (WITHHYPSEL (WITHARGSEL thm)))))
        (LETHYPS _As
            (Fail ("At present I2L Jape can't deal with multiple antecedent selections when applying theorems. Sorry.\
                    \\nCancel one of them and try again.")))
        (LETGOAL _A
            (ALT (WITHARGSEL thm) 
                (RESOLVE (WITHARGSEL thm)) 
                (TheoremForward (WITHARGSEL thm))
                (Fail   "Theorem application failed -- tell Richard")))
        (LETOPENSUBGOAL G _A 
            (Fail ("Error in I2L Jape (open subgoal in TheoremForwardOrBackward). Tell Richard.")))
        (LETOPENSUBGOALS _As
            (ALERT  ("There is more than one unproved conclusion in the proof. Please select one – \
                        \or select an antecedent – to show \
                        \Jape where to apply the theorem.")
                    ("OK", STOP) 
                    ("Huh?", Explainantecedentandconclusionwords)))
        (ALERT  "The proof is finished -- there are no unproved conclusions left."
                ("OK", STOP) 
                ("Huh?", Explainunprovedconclusionwords))

/* These theorems are all stated without an explicit left context Γ. That is possible because, in I2L_rules.j,
 * we declared a WEAKEN structure rule: Jape will automatically discard any unmatched left-context
 * formulae.
 */
  
/* Panels are declared in reverse order because the GUIs,  quite reasonably, create panels in the order requested.
 * Thus the last you ask for is the last created, and appears at the front of the stack.
 */

CONJECTUREPANEL "Examenes"
 /* Examen de Septiembre de 2004 */
 /*  1 */ THEOREM IS ∀x.P(x) ∨ ∀x.Q(x) 
                     ⊦ ∀x.(P(x) ∨ Q(x))
 /*  2 */ THEOREM IS ∃x.(P(x) ∧ Q(x)) 
                     ⊦ ∃x.P(x) ∧ ∃x.Q(x) 
 /* Segundo parcial de 2005 */
 /*  3 */ THEOREM IS ∀x.(R(x) → Q(x)),
                     ∃x.(P(x) ∧ ¬Q(x)) 
                     ⊦ ∃x.(P(x) ∧ ¬R(x))
 /* Segundo parcial de 2005 */
 /*  4 */ THEOREM IS ∃x.(P(x)∧Q(x)), 
                     ∀y.(P(y)→R(y)) 
                     ⊦ ∃x.(R(x)∧Q(x))
 /*  5 */ THEOREM IS ∀x.R(x,x), 
                     ∀x.∀y.∀z.(¬R(x,y)∧¬R(y,z)→¬R(x,z)) 
                     ⊦ ∀x.∀y.(R(x,y)∨R(y,x))
 /*  6 */ THEOREM IS ∃x.∃y.(R(x,y)∨R(y,x)) 
                     ⊦ ∃x.∃y.R(x,y)
 /*  7 */ THEOREM IS ∀x.(P(x)→∃y.Q(y)), 
                     actual i 
                     ⊦ ∀x.∃y.(P(x)→Q(y))
 /* Segundo parcial de 2005 */
 /* 8 */ THEOREM IS ∀x.(P(x) → ¬C(x)),
                     ∃x.(C(x) ∧ B(x))
                     ⊦ ∃x.(B(x) ∧ ¬P(x))
 /* Segundo parcial de 2005 */
 /*  9 */ THEOREM IS ∀x.∃y.(P(x)→Q(y)) 
                     ⊦ ∀x.(P(x)→∃y.Q(y))
 /* 10 */ THEOREM IS ¬∀x.(P(x)→Q(a)) 
                     ⊦ ∃x.P(x)∧¬Q(a)
 /* 11 */ THEOREM IS ∀x.P(x), 
                     ∀x.(P(x)→Q(x)∨R(x)), 
                     ∃x.¬Q(x) 
                     ⊦ ∃x.R(x)
 /* 12 */ THEOREM IS ∀x.∀y.(R(x,y)→R(y,x)), 
                     ∀x.∀y.(R(x,y)∨R(y,x)) 
                     ⊦ ∀x.∀y.∀z.(¬R(x,y)∧¬R(y,z)→¬R(x,z))
 /* Examen de Junio de 2005 */
 /* 13 */ THEOREM IS ¬(∀x.P(x)) 
                     ⊦ ∃x.¬P(x)
 /* 14 */ THEOREM IS ∀x.∀y.((∃z.R(y,z)) → R(x,y)), 
                     ∃x.∃y.R(x,y)
                     ⊦ ∀x.∀y.R(x,y)
 /* Examen de Septiembre de 2005 */
 /* 15 */ THEOREM IS ∃x.(P(x)∧¬Q(x))→∀y.(P(y)→R(y)), 
                     ∃x.(P(x)∧S(x)), 
                     ∀x.(P(x)→¬R(x)) 
                     ⊦ ∃x.(S(x)∧Q(x))
 /* 16 */ THEOREM IS ⊦ ¬∃x.∀y.(P(y,x)↔¬P(y,y))
 /* Examen de Diciembre de 2005 */
 /* 17 */ THEOREM IS ∀x.(∃y.R(x,y)→∃y.(∀z.R(y,z)∧R(x,y))), 
                     ∃x.∃y.R(x,y) 
                     ⊦ ∃x.∀y.R(x,y)
 /* 18 */ THEOREM IS ∀x.(P(x)→∀y.(Q(y)→R(x,y))), 
                     ∃x.(P(x)∧∃y.¬R(x,y)) 
                     ⊦ ¬∀x.Q(x)
 /* Segundo parcial de 2006 */
 /* 19 */ THEOREM IS ∃x.(P(x)→∀y.Q(y)) 
                     ⊦ ∃x.∀y.(P(x)→Q(y))
 /* 20 */ THEOREM IS ∃y.∃z.(∀x.¬R(x,y)∨∀x.¬R(x,z)) 
                     ⊦ ¬∀y.∀z.∃x.(R(x,y)∧R(x,z))
 /* 21 */ THEOREM IS ∃x.(P(x)→∀y.(P(y)→Q(y))), 
                     ¬∃x.Q(x) 
                     ⊦ ¬∀x.P(x)
 /* 22 */ THEOREM IS ¬∃x.(P(x)∧¬∀y.(Q(y)→R(x,y))), 
                     ∃x.(P(x)∧∃y.¬R(x,y)) 
                     ⊦ ∃x.¬Q(x)
 /* 23 */ THEOREM IS ∀x.∀y.(∃z.(R(z,y)∧¬R(x,z))→R(x,y)), 
                     ¬∃x.R(x,x) 
                     ⊦ ∀x.∀y.(¬R(y,x)→¬R(x,y))
 /* 24 */ THEOREM IS P(a)→¬∀x.¬R(x), actual i1 
                     ⊦ ¬∀x.(¬R(x)∧P(a))
 /* 25 */ THEOREM IS ∀x.∀y.∀z.(P(x,y)∧P(y,z)→R(x,z)), 
                     ∀x.∃y.P(x,y) 
                     ⊦ ∀x.∃y.R(x,y)
 /* 26 */ THEOREM IS ∀x.(P(x)→(∃y.Q(x,y)→∃y.Q(y,x))), 
                     ∀x.(∃y.Q(y,x)→Q(x,x)), 
                     ¬∃x.Q(x,x) 
                     ⊦ ∀x.(P(x)→∀y.¬Q(x,y))
 /* Examen de Junio de 2006 */
 /* 27 */ THEOREM IS ∀x.(Q(x)→¬R(x)), 
                     ∀x.(P(x)→Q(x)∨S(x)), 
                     ∃x.(P(x)∧R(x)) 
                     ⊦ ∃x.(P(x)∧S(x))
 /* Examen de Septiembre de 2006 */
 /* 28 */ THEOREM IS ∀x.(P(x)→(R(x)→S(x))), 
                     ∃x.(P(x)∨¬R(x)) 
                     ⊦ ∃x.(R(x)→S(x))
 

 BUTTON Apply IS apply TheoremForwardOrBackward COMMAND
 
END

CONJECTUREPANEL "Ejercicios propuestos"
    THEOREM IS ∀ x.(P(x) → Q(x)) ⊦ ∀ x.P(x) → ∀ x.Q(x)
    THEOREM IS ∃ x.¬ P(x) ⊦ ¬ ∀ x.P(x)
    THEOREM IS ∀ x.P(x) ⊦ ∀ y.P(y)
    THEOREM IS ∀ x.(P(x) → Q(x)) ⊦ 
               (∀ x.¬ Q(x)) → (∀ x.¬ P(x))
    THEOREM IS ∀ x.(P(x) → ¬ Q(x)) ⊦
               ¬(∃ x.(P(x) ∧ Q(x)))

    THEOREM IS ∀ x.∀ y.P(x,y) ⊦ ∀ u.∀ v.P(u,v)
    THEOREM IS ∃ x.∃ y.P(x,y) ⊦ ∃ u.∃ v.P(u,v)
    THEOREM IS ∃ x.∀ y.P(x,y) ⊦ ∀ y.∃ x.P(x,y)

    THEOREM IS ∃ x.(P(a) → Q(x)) ⊦ P(a) → ∃ x.Q(x)
    THEOREM IS P(a) → ∃ x.Q(x), actual i ⊦ ∃ x.(P(a) → Q(x))
    THEOREM IS ∃ x.P(x) → Q(a) ⊦ ∀ x.(P(x) → Q(a))
    THEOREM IS ∀ x.(P(x) → Q(a)), actual i ⊦ ∃ x.(P(x) → Q(a))

    THEOREM IS ∀ x.P(x) ∨ ∀ x.Q(x) ⊦ ∀ x.(P(x) ∨ Q(x))
    THEOREM IS ∃ x.(P(x) ∧ Q(x)) ⊦ ∃ x.P(x) ∧ ∃ x.Q(x)
    THEOREM IS ∀ x.∀ y.(P(y) → Q(x)) ⊦ ∃ y.P(y) → ∀ x.Q(x)
    THEOREM IS ¬ ∀ x.¬ P(x), actual j ⊦ ∃ x.P(x)
    THEOREM IS ∀ x.¬ P(x) ⊦ ¬ ∃ x.P(x)
    THEOREM IS ∃ x.P(x) ⊦ ¬ ∀ x.¬ P(x)
    THEOREM IS P(a) → ∀ x.Q(x) ⊦ ∀ x.(P(a) → Q(x))
    THEOREM IS ∀ x.∀ y.∀ z.(R(x,y) ∧ R(y,z) → R(x,z)),
               ∀ x.¬ R(x,x)
               ⊦ ∀ x.∀ y.(R(x,y) → ¬ R(y,x))
    THEOREM IS ∀ x.(P(x) ∨ Q(x)),
               ∃ x.¬ Q(x),
               ∀ x.(R(x) → ¬ P(x))
               ⊦ ∃ x.¬ R(x)
    THEOREM IS ∀ x.(P(x) → (Q(x) ∨ R(x))),
               ¬ ∃ x.(P(x) ∧ R(x))
               ⊦ ∀ x.(P(x) → Q(x))
    THEOREM IS ∃ x.∃ y.(R(x,y) ∨ R(y,x)) ⊦ ∃ x.∃ y.R(x,y)

    BUTTON Apply IS apply TheoremForwardOrBackward COMMAND
END

CONJECTUREPANEL "Ejemplos de clase"
   
 /* Reglas del generalizador */
 /* E01 p. 114 */ THEOREM INFER actual y, P(y),∀x.(P(x)→¬ Q(x)) ⊦ ¬Q(y) 
 /* E02 p. 114 */ THEOREM INFER ∀x.(P(x) → Q(x)), ∀x.P(x) ⊦ ∀x.Q(x)
 
 /* Reglas del particularizador */

 /* E03 p. 117 */ THEOREM INFER actual j, ∀x.P(x) ⊦ ∃x.P(x)
 /* E04 p. 117 */ THEOREM INFER ∀x.(P(x) → Q(x)), ∃x.P(x) ⊦ ∃x.Q(x)
 /* E05 p. 118 */ THEOREM INFER ∀x.(Q(x) → R(x)), ∃x.(P(x) ∧ Q(x)) ⊦ ∃x.(P(x) ∧ R(x))
 /* E06 p. 119 */ THEOREM INFER ∃x.P(x), ∀x.∀y.(P(x) → Q(y)) ⊦ ∀y.Q(y)

 /* Equivalencias */
 /* E07 p. 123 */ THEOREM INFER ¬(∀x.P(x)) ⊦ ∃x.¬P(x)
 /* E08 p. 123 */ THEOREM INFER ∃x.¬P(x) ⊦ ¬(∀x.P(x)) 
 /* E09 p. 123 */ THEOREM INFER ⊦ ¬(∀x.P(x)) ↔ ∃x.¬P(x)
 /* E10 p. 124 */ THEOREM INFER ∀x.(P(x) ∧ Q(x)) ⊦ ∀x.P(x) ∧ ∀x.Q(x)
 /* E11 p. 124 */ THEOREM INFER ∀x.P(x) ∧ ∀x.Q(x) ⊦ ∀x.(P(x) ∧ Q(x))
 /* E12 p. 124 */ THEOREM INFER ⊦ ∀x.(P(x) ∧ Q(x)) ↔ ∀x.P(x) ∧ ∀x.Q(x)
 /* E13 p. 117 */ THEOREM INFER ∃x.P(x) ∨ ∃x.Q(x) ⊦ ∃x.(P(x) ∨ Q(x))
 /* E14 p. 117 */ THEOREM INFER ∃x.(P(x) ∨ Q(x)) ⊦ ∃x.P(x) ∨ ∃x.Q(x)
 /* E15 p. 117 */ THEOREM INFER ⊦ ∃x.P(x) ∨ ∃x.Q(x) ↔ ∃x.(P(x) ∨ Q(x))
 /* E16 p. 117 */ THEOREM INFER ∃x.∃y.P(x,y) ⊦ ∃y.∃x.P(x,y)
 /* E17 p. 117 */ THEOREM INFER ⊦ ∃x.∃y.P(x,y) ↔ ∃y.∃x.P(x,y)

 BUTTON Apply IS apply TheoremForwardOrBackward COMMAND
END
